Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package reflect
  Definition Classes
    scala
-  package macros
  Definition Classes
    reflect
-  package util
  Definition Classes
    macros
- Helpers
- Traces

t

scala.reflect.macros.util

# Helpers

###

#### trait Helpers extends AnyRef

Self Type
  Analyzer
Source
  Helpers.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
erasure, treeChecker, ScaladocAnalyzer, InteractiveAnalyzer, Erasure, Duplicator, SpecializationDuplicator, Analyzer, Duplicators, Macros, TreeCheckers
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Helpers
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Helpers toany2stringadd[Helpers] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Helpers, B)
   Implicit
     This member is added by an implicit conversion from Helpers toArrowAssoc[Helpers] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
8.  def decreaseMetalevel(tp: tools.nsc.Global.Type): tools.nsc.Global.Type

   Decreases metalevel of the type, i.e.

   Decreases metalevel of the type, i.e. transforms: * c.Expr[T] to T * Nothing to Nothing * Anything else to NoType

   See also

     Metalevels.scala for more information and examples about metalevels

9.  def ensuring(cond: (Helpers) => Boolean, msg: => Any): Helpers
   Implicit
     This member is added by an implicit conversion from Helpers toEnsuring[Helpers] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: (Helpers) => Boolean): Helpers
    Implicit
      This member is added by an implicit conversion from Helpers toEnsuring[Helpers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean, msg: => Any): Helpers
    Implicit
      This member is added by an implicit conversion from Helpers toEnsuring[Helpers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean): Helpers
    Implicit
      This member is added by an implicit conversion from Helpers toEnsuring[Helpers] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
14.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
15.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
16.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Helpers toStringFormat[Helpers] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
17.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
18.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
19.  def increaseMetalevel(pre: tools.nsc.Global.Type, tp: tools.nsc.Global.Type): tools.nsc.Global.Type

    Increases metalevel of the type, i.e.

    Increases metalevel of the type, i.e. transforms: * T to c.Expr[T]

    See also

      Metalevels.scala for more information and examples about metalevels

20.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
21.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
22.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
23.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
24.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
25.  def toString(): String
    Definition Classes
      AnyRef → Any
26.  def transformTypeTagEvidenceParams(macroImplRef: tools.nsc.Global.Tree, transform: (tools.nsc.Global.Symbol, tools.nsc.Global.Symbol) => tools.nsc.Global.Symbol): List[List[tools.nsc.Global.Symbol]]

    Transforms parameters lists of a macro impl.

    Transforms parameters lists of a macro impl. The `transform` function is invoked only for WeakTypeTag evidence parameters.

    The transformer takes two arguments: a value parameter from the parameter list and a type parameter that is witnesses by the value parameter.

    If the transformer returns a NoSymbol, the value parameter is not included from the result. If the transformer returns something else, this something else is included in the result instead of the value parameter.

    Despite of being highly esoteric, this function significantly simplifies signature analysis. For example, it can be used to strip macroImpl.paramss from the evidences (necessary when checking def <-> impl correspondence) or to streamline creation of the list of macro arguments.

27.  def untypeMetalevel(tp: tools.nsc.Global.Type): tools.nsc.Global.Type

    Transforms c.Expr[T] types into c.Tree and leaves the rest unchanged.

28.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
29.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
30.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (Helpers, B)
   Implicit
     This member is added by an implicit conversion from Helpers toArrowAssoc[Helpers] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromHelpers to any2stringadd[Helpers]

### Inherited by implicit conversion StringFormat fromHelpers to StringFormat[Helpers]

### Inherited by implicit conversion Ensuring fromHelpers to Ensuring[Helpers]

### Inherited by implicit conversion ArrowAssoc fromHelpers to ArrowAssoc[Helpers]

### Ungrouped